package name.dsouflis.aop.synthgetter;

import java.io.IOException;
import java.util.HashMap;
import java.lang.reflect.Field;

/**
 * Created by IntelliJ IDEA.
 * User: Dsouflis
 * Date: 21 Δεκ 2006
 * Time: 2:27:58 μμ
 * To change this template use File | Settings | File Templates.
 */
public class Test {
    public static void main(String[] args) throws IOException, ClassNotFoundException, IllegalAccessException, InstantiationException, NoSuchFieldException {
        HashMap<String, String> map = new HashMap<String, String>();
        map.put("bar","bar");
        ObjectLocator objectLocator = new ObjectLocator() {
            public Object getObject(String id) {
                if("bar".equals(id)) {
                    return new Bar("qqqq");
                } else {
                    return null;
                }
            }
        };
        String className = "name.dsouflis.aop.synthgetter.Foo";
        SyntheticGetterClassLoader syntheticGetterClassLoader = new SyntheticGetterClassLoader(className, map);
        org.apache.bcel.classfile.JavaClass javaClass = syntheticGetterClassLoader.classWithSyntheticGetters(className+SyntheticGetterClassLoader.implSuffix);
        javaClass.dump(new java.io.File("c:/temp/Foo.class"));
        Class<?> aClass = syntheticGetterClassLoader.loadClass(className+SyntheticGetterClassLoader.implSuffix);
        Object o = aClass.newInstance();
        Field field = aClass.getField("$objectLocator");
        field.set(o, objectLocator);
        System.out.println("foo="+o.toString());
    }
}
